type action = Sast | Compile | Translator | Typecheck | All


let _ =
  let action = if Array.length Sys.argv > 1 then
      List.assoc Sys.argv.(1) [ ("-a", Sast);
                                ("-j", Translator);
                                ("-t", Typecheck);
                                ("-c", All)]
  else Compile in
  let input_file = ref Sys.argv.(2) in
  let input = open_in !input_file in
  let lexbuf = Lexing.from_channel input in
  let program = Parser.program Scanner.token lexbuf in
  match action with

   Translator ->
    let listing =
      Translator.jstring_of_program (Typecheck.translate program) !input_file
    in print_endline listing
  | All ->
     ignore (Typecheck.translate program);
     let listing =
            Translator.jstring_of_program (Typecheck.translate program) !input_file
     in print_endline listing
     