﻿open Sast


let package_del = "package ec;" (* Package declaration. *)
let import_decl = "" (* Import needed packages. Not needed now. *)
(* Java code of the defination of the inner class of Res. *)
let res_def= "\n public static class Res {\n double value; \n public Res(){ \n  super(); \n  } \n public Res(double name){ \n this.value=name; \n } \n }"
(* Java code of the defination of the inner class of Bit. *)
let bit_def="	public static class Bit {
		String value;
		public static boolean[] BinstrToBool(String input) {
			boolean[] output = new boolean[input.length()];
			for (int i = 0; i < input.length(); i++)
				if (input.charAt(i) == '1')
					output[i] = true;
				else if (input.charAt(i) == '0')
					output[i] = false;
			return output;
		}
	}
"
(* Java code of getParallel method which compute parallel resistance. *)
let getParallel_fun_def="\n public static Res getParallel (Res r1,Res r2){ \n Res rp=new Res(); \n rp.value=1/(1/r1.value+1/r2.value); \n return rp; \n }"
(* Java code of getSerial method which compute serially connected resistance. *)
let getSerial_fun_def="\n public static Res getSerial (Res r1,Res r2){ \n Res rs=new Res(); \n rs.value=r1.value+r2.value; \n	 return rs; \n	 }"
(* Java code of method that computes AND operation for two BIT type variables method. *)
let  compute_AND_fun_def= "public static Bit aANDb(Bit a, Bit b) {
		Bit resultBit = new Bit();
		int lmin = Math.min(a.value.length(), b.value.length());
		int lmax = Math.max(a.value.length(), b.value.length());
		boolean[] result = new boolean[lmin];
		for (int i = 0; i < lmin; i++) {
			result[i] = Bit.BinstrToBool(a.value)[i]
					&& Bit.BinstrToBool(b.value)[i];
		}

		String resultStr = new String();
		for (int i = 0; i < lmin; i++) {
			if (result[i])
				resultStr = resultStr + \"1\";
			else
				resultStr = resultStr + \"0\";
		}
		for (int i = 0; i < lmax - lmin; i++) {
			resultStr = resultStr + \"0\";
		}
		resultBit.value = resultStr;
		return resultBit;
	}"
	(* Java code of method that computes OR operation for two BIT type variables method. *)

let compute_OR_fun_def="public static Bit aORb(Bit a, Bit b) {
		Bit resultBit = new Bit();
		int lmin = Math.min(a.value.length(), b.value.length());
		int lmax = Math.max(a.value.length(), b.value.length());
		boolean[] result = new boolean[lmin];
		for (int i = 0; i < lmin; i++) {
			result[i] = Bit.BinstrToBool(a.value)[i]
					|| Bit.BinstrToBool(b.value)[i];
		}

		String resultStr = new String();
		for (int i = 0; i < lmin; i++) {
			if (result[i])
				resultStr = resultStr + \"1\";
			else
				resultStr = resultStr + \"0\";
		}
		for (int i = 0; i < lmax - lmin; i++) {
			resultStr = resultStr + \"0\";
		}
		resultBit.value = resultStr;
		return resultBit;
	}"
(* Java code of main method declaration *)
let main_fdecl = "\n public static void main(String[] args) throws Exception\n{\nECStart();\n}\n"
(* Concatenate the java code of pre-defined inner class Res and functions *)
let begin_code_necessary= main_fdecl
let begin_code_with_res= res_def  ^ getParallel_fun_def ^ getSerial_fun_def   ^ main_fdecl
let begin_code_with_bit=  bit_def ^   compute_AND_fun_def ^ compute_OR_fun_def ^ main_fdecl
let begin_code_with_res_and_bit= res_def ^ bit_def ^ getParallel_fun_def ^ getSerial_fun_def ^ compute_AND_fun_def ^ compute_OR_fun_def ^ main_fdecl

let jstring_of_datatype dtype =
  match dtype with
    Ast.Int -> "int"
  |  Ast.Float -> "double"
  |  Ast.Boolean -> "boolean"
  |  Ast.Void -> "void"
  | Ast.String -> "String"
	| Ast.Res -> "Res"
	|  Ast.Bit ->"Bit"     

let rec jstring_of_expr global_vars local_vars = function
	Literal(ll)-> 
		(match ll with
		 Ast.IntLit(i)-> string_of_int i
		| Ast.FloatLit(f)-> string_of_float f
		|  Ast.BinaryLit(b)-> b
		|  Ast.SentenceLit(s)-> s)
	|Id(l)->l.vvname
	| Binop(et1, o, et2) -> 
		let (e1,eu1) =et1 in
		let (e2,eu2) =et2 in
		 (match o with
		|   Ast.Add -> jstring_of_expr global_vars local_vars e1 ^ "+"  ^ " " ^ jstring_of_expr global_vars local_vars e2
		|   Ast.Sub -> jstring_of_expr global_vars local_vars e1 ^ "-"  ^ " " ^ jstring_of_expr global_vars local_vars e2
		|   Ast.Mult -> jstring_of_expr global_vars local_vars e1 ^ "*"  ^ " " ^ jstring_of_expr global_vars local_vars e2
		|   Ast.Div -> jstring_of_expr global_vars local_vars e1 ^ "/"  ^ " " ^ jstring_of_expr global_vars local_vars e2
		|   Ast.Gt ->jstring_of_expr global_vars local_vars e1 ^ ">"  ^ " " ^ jstring_of_expr global_vars local_vars e2
		|   Ast.Ne ->jstring_of_expr global_vars local_vars e1 ^ "!="  ^ " " ^ jstring_of_expr global_vars local_vars e2
		|   Ast.Lt ->jstring_of_expr global_vars local_vars e1 ^ "<"  ^ " " ^ jstring_of_expr global_vars local_vars e2
		|   Ast.Le ->jstring_of_expr global_vars local_vars e1 ^ "<="  ^ " " ^ jstring_of_expr global_vars local_vars e2
		|   Ast.Ge ->jstring_of_expr global_vars local_vars e1 ^ ">="  ^ " " ^ jstring_of_expr global_vars local_vars e2
		|   Ast.Eq ->jstring_of_expr global_vars local_vars e1 ^ "=="  ^ " " ^ jstring_of_expr global_vars local_vars e2
		|   Ast.Series -> " getSerial(" ^ jstring_of_expr global_vars local_vars  e1 ^ ","  ^ " " ^ jstring_of_expr global_vars local_vars e2 ^ ")"
		|   Ast.Parallel -> " getParallel(" ^ jstring_of_expr global_vars local_vars  e1 ^ ","  ^ " " ^ jstring_of_expr global_vars local_vars e2 ^ ")"
		|   Ast.And -> " aANDb(" ^ jstring_of_expr global_vars local_vars  e1 ^ ","  ^ " " ^ jstring_of_expr global_vars local_vars e2 ^ ")"
		|   Ast.Or ->"aORb(" ^ jstring_of_expr global_vars local_vars  e1 ^ ","  ^ " " ^ jstring_of_expr global_vars local_vars e2 ^ ")"
		)	
	|Unary (op,et)->
		let (e,eu)=et in
		(match op with
		| Ast.Reciprocal -> "(1/" ^ jstring_of_expr global_vars local_vars e ^")"
		|  Ast.Plus->  "(+" ^ jstring_of_expr global_vars local_vars e ^")"
		|  Ast.Minus->  "(-" ^ jstring_of_expr global_vars local_vars e ^")")
	| Afterop (ent,aft)-> let (en,eu)=ent in jstring_of_expr global_vars local_vars en ^".value "
	|  Assign (at,bt) -> let (a,au)=at in let (b,bu)=bt in jstring_of_expr global_vars local_vars a ^"="^ jstring_of_expr global_vars local_vars b 
 | Call(f, elt) -> 
      (match f with
        "show" -> "System.out.println(" ^ (String.concat "" (List.map (jstring_of_expr global_vars local_vars) (List.map (	fun (a1,a2)->a1) elt) )) ^ ")"
			
     | _ -> f ^ "(" ^ String.concat ", " (List.map (jstring_of_expr global_vars local_vars) (List.map (	fun (a1,a2)->a1) elt)) ^ ")"
      )
			
	 | Noexpr -> ""
          
let rec jstring_of_stmt global_vars local_vars = function
    Block(decls, stmts) ->
      "{\n" ^ String.concat "" (List.map (jstring_of_stmt global_vars local_vars) stmts) ^ "}\n"
  | Expr(exprt) -> let (expr,expru)=exprt in jstring_of_expr global_vars local_vars expr ^ ";\n";
  | Return(exprt) -> let (expr,expru)=exprt in  "return " ^ jstring_of_expr global_vars local_vars expr ^ ";\n";
  | If(et, s, Block([],[])) ->  let (e,eu)=et in "if (" ^ jstring_of_expr global_vars local_vars e ^ ")\n" ^ jstring_of_stmt global_vars local_vars s
  | If(et, s1, s2) -> let (e,eu)=et in "if (" ^ jstring_of_expr global_vars local_vars e ^ ")\n" ^
      jstring_of_stmt global_vars local_vars s1 ^ "else\n" ^ jstring_of_stmt global_vars local_vars s2
  | For(e1t, e2t, e3t, s) -> let (e1,e1u)=e1t in let (e2,e2u)=e2t in let (e3,e3u)=e3t in
      "for (" ^ jstring_of_expr global_vars local_vars e1  ^ " ; " ^ jstring_of_expr global_vars local_vars e2 ^ " ; " ^
      jstring_of_expr global_vars local_vars e3  ^ ") " ^ jstring_of_stmt global_vars local_vars s
  | While(et, s) ->  let (e,eu)=et in "while (" ^ jstring_of_expr global_vars local_vars e ^ ") " ^ jstring_of_stmt global_vars local_vars s


let jstring_of_vdecl vdecl = match (vdecl.vvtype) with
|  Ast.Res -> (jstring_of_datatype vdecl.vvtype) ^ " " ^ vdecl.vvname ^ "=new "^ (jstring_of_datatype vdecl.vvtype) ^"()"^" ;\n"
|  Ast.Bit ->   (jstring_of_datatype vdecl.vvtype) ^ " " ^ vdecl.vvname ^ "=new "^ (jstring_of_datatype vdecl.vvtype) ^"()"^" ;\n"
| _ ->  (jstring_of_datatype vdecl.vvtype) ^ " " ^ vdecl.vvname ^ " ;\n"

let jstring_of_gvdecl gvdecl =
  "public static " ^ jstring_of_vdecl gvdecl

let jstring_of_formal formal =
  jstring_of_datatype formal.vvtype ^ " " ^ formal.vvname
	
let jstring_of_fdecl global_vars fdecl =
  let local_vars = (List.map (fun a -> { vvname = a.vvname; vvtype = a.vvtype }) fdecl.fformals)
                   @ (List.map (fun a -> { vvname = a.vvname; vvtype = a.vvtype }) fdecl.flocals)
  in
  (match fdecl.ffname with
    "main" -> "static " ^ jstring_of_datatype fdecl.frtype  ^ " ECStart()"
    | _ -> "static " ^ jstring_of_datatype fdecl.frtype ^ " " ^ fdecl.ffname ^
           "(" ^  String.concat ", " (List.map jstring_of_formal fdecl.fformals) ^ ")"
   ) ^
  "\n{\n" ^
  String.concat "" (List.map jstring_of_vdecl fdecl.flocals) ^
  String.concat "" (List.rev(List.map (jstring_of_stmt global_vars local_vars) fdecl.fbody)) ^
  "}\n"

let jstring_of_header (g_var, l_var)=
	
  let global_vars = List.map (fun a -> { vvname = a.vvname; vvtype = a.vvtype }) g_var
 	in
	let global_vars_type_list = List.map (fun a ->  a.vvtype ) global_vars
	in
	let funcs_locals_list=List.map ( fun a -> {frtype=a.frtype; ffname=a.ffname;fformals=a.fformals; flocals=a.flocals;fbody=a.fbody})l_var
	in
let funcs_locals_type_list_temp1 =List.map (fun a ->  a.flocals) funcs_locals_list

in
let funcs_locals_type_list_temp2=List.concat  funcs_locals_type_list_temp1

in
	let funcs_locals_type_list =List.map(fun a-> a.vvtype)funcs_locals_type_list_temp2 in
	
	
	
	let funcs_formals_list=List.map ( fun a -> {frtype=a.frtype; ffname=a.ffname;fformals=a.fformals; flocals=a.flocals;fbody=a.fbody})l_var
	in
let funcs_formals_type_list_temp1 =List.map (fun a ->  a.fformals ) funcs_formals_list

in
let funcs_formals_type_list_temp2=List.concat  funcs_formals_type_list_temp1

in
	let funcs_formals_type_list =List.map(fun a-> a.vvtype)funcs_formals_type_list_temp2 in
		
let vars_type_list = global_vars_type_list
@(funcs_locals_type_list)@funcs_formals_type_list
  in
	if( List.mem  Ast.Res vars_type_list && List.mem  Ast.Bit vars_type_list) then begin_code_with_res_and_bit 
	else if( List.mem  Ast.Res vars_type_list) then begin_code_with_res
	else if( List.mem  Ast.Bit vars_type_list) then begin_code_with_bit
	else begin_code_necessary
	
let jstring_of_program (vars, funcs)  file_name  =
	let header=jstring_of_header (vars, funcs)in
  let global_vars = List.map (fun a -> { vvname = a.vvname; vvtype = a.vvtype }) vars
  in
  package_del ^ "\n" ^ import_decl ^ "\n\n" ^
  "public class " ^ (String.sub file_name 0 ((String.length file_name) - 3)) ^"_result"^
  "\n{\n" ^header  ^
  String.concat "" (List.map jstring_of_gvdecl vars) ^ "\n\n" ^
  String.concat "\n" (List.map (jstring_of_fdecl global_vars) funcs) ^
  "\n}" 





